"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCurrent = useCurrent;
exports.default = connect;

var _DependencyMap = require("./DependencyMap");

var _BuildComponent = require("./BuildComponent");

var _DependencyMap2 = require("../dependencies/DependencyMap");

var _DispatcherInstance = require("../dispatcher/DispatcherInstance");

var _DispatcherInterface = require("../dispatcher/DispatcherInterface");

var React = _interopRequireWildcard(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _Dispatch = require("./Dispatch");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function useCurrent(value) {
  var ref = (0, React.useRef)(value);
  ref.current = value;
  return ref;
}

function connect(dependencies) {
  var dispatcher = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _DispatcherInstance.get)();
  (0, _DispatcherInterface.enforceDispatcher)(dispatcher);
  var dependencyIndex = (0, _DependencyMap.makeDependencyIndex)(dependencies);
  return function connector(BaseComponent) {
    var ConnectedComponent = /*#__PURE__*/function (_React$Component) {
      _inherits(ConnectedComponent, _React$Component);

      var _super = _createSuper(ConnectedComponent);

      _createClass(ConnectedComponent, null, [{
        key: "getDerivedStateFromProps",
        value: function getDerivedStateFromProps(props, state) {
          return (0, _DependencyMap.calculateInitial)(dependencies, props, state);
        }
      }]);

      function ConnectedComponent(props) {
        var _this;

        _classCallCheck(this, ConnectedComponent);

        _this = _super.call(this, props);

        _defineProperty(_assertThisInitialized(_this), "dispatchToken", void 0);

        _defineProperty(_assertThisInitialized(_this), "state", {});

        _defineProperty(_assertThisInitialized(_this), "wrappedInstance", null);

        _defineProperty(_assertThisInitialized(_this), "focus", typeof BaseComponent.prototype.focus === 'function' ? function () {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return _BuildComponent.focuser.apply(void 0, [_assertThisInitialized(_this)].concat(args));
        } : undefined);

        _defineProperty(_assertThisInitialized(_this), "setWrappedInstance", function (ref) {
          _this.wrappedInstance = ref;
        });

        if (dispatcher) {
          _this.dispatchToken = dispatcher.register(_Dispatch.handleDispatch.bind(null, dispatcher, dependencyIndex, _this.handleDispatch.bind(_assertThisInitialized(_this))));
        }

        _this.state = (0, _DependencyMap.calculateInitial)(dependencies, _this.props, {});
        return _this;
      }

      _createClass(ConnectedComponent, [{
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          var dispatchToken = this.dispatchToken;

          if (dispatcher && dispatchToken) {
            this.dispatchToken = null;
            dispatcher.unregister(dispatchToken);
          }
        }
      }, {
        key: "handleDispatch",
        value: function handleDispatch(entry) {
          this.setState((0, _DependencyMap.calculateForDispatch)(dependencies, entry, this.props, this.state));
        }
      }, {
        key: "render",
        value: function render() {
          var refProps = typeof BaseComponent === 'function' ? {} : {
            ref: this.setWrappedInstance
          };
          return /*#__PURE__*/React.createElement(BaseComponent, _extends({}, this.props, this.state, refProps));
        }
      }]);

      return ConnectedComponent;
    }(React.Component);

    _defineProperty(ConnectedComponent, "defaultProps", BaseComponent.defaultProps);

    _defineProperty(ConnectedComponent, "dependencies", dependencies);

    _defineProperty(ConnectedComponent, "displayName", (0, _BuildComponent.makeDisplayName)('Connected', BaseComponent));

    _defineProperty(ConnectedComponent, "propTypes", (0, _DependencyMap2.dependencyPropTypes)(dependencies, // eslint-disable-next-line react-app/react/forbid-foreign-prop-types
    BaseComponent.propTypes));

    _defineProperty(ConnectedComponent, "WrappedComponent", BaseComponent);

    return (0, _hoistNonReactStatics.default)(ConnectedComponent, BaseComponent);
  };
}